# Generated by Django 2.1.7 on 2019-06-06 12:06

from django.db import migrations, models, transaction
from angled.ui import UNITS_NAMES
from angled.models import dyn


def default_unit_name(apps, schema_editor):
    index_model = apps.get_model('angled', 'listindex')

    # iterate over units
    for u in UNITS_NAMES:
        if (u == 'document') | (
                u == 'actor'
        ):  # multi_document and multi_actor are not created at this stage
            pass
        else:
            try:
                if dyn.is_multi(u):
                    multi = apps.get_model('angled', 'multi_{}'.format(u))
                    # iterate over multi
                    for i in multi.objects.all():
                        new_index = index_model.objects.get(pk=i.index.id)
                        if new_index.unit is None:
                            new_index.unit = u
                            new_index.save()
            except Exception:
                pass

    # remove index that we could not associate with an unit name
    for index in index_model.objects.all().filter(unit=None):
        index.delete()


class Migration(migrations.Migration):

    dependencies = [
        ('angled', '0014_auto_20190606_1045'),
    ]

    operations = [
        migrations.AddField(
            model_name='listindex',
            name='unit',
            field=models.CharField(max_length=50, null=True),
        ),
        migrations.RunPython(default_unit_name),
    ]
